import board, neopixel, time, digitalio
import mount_sd

from audiopwmio import PWMAudioOut as AudioOut
from audiocore import WaveFile
from adafruit_debouncer import Button


def play_sound_begin(filename):
    with open(path + filename, "rb") as wave_file:
        wave = WaveFile(wave_file)
        audio.play(wave)
        while audio.playing:
            pixels[2:8] = RED * 6
            pixels[10:16] = GREEN * 6
            time.sleep(0.15)

            pixels[2:8] = BLACK * 6
            pixels[10:16] = BLACK * 6
            time.sleep(0.15)

def play_sound_winner(winner):
    if winner == "BC":
        with open(path + "bc-wins.wav", "rb") as wave_file:
            wave = WaveFile(wave_file)
            audio.play(wave)
            while audio.playing:
                for i in range(8):
                    pixels[2:8] = RED * 6
                    time.sleep(0.15)
                    pixels[2:8] = BLACK * 6
                    time.sleep(0.15)

    if winner == "DM":
        with open(path + "Dartmouth-Wins.wav", "rb") as wave_file:
            wave = WaveFile(wave_file)
            audio.play(wave)
            while audio.playing:
                for i in range(8):
                    pixels[10:16] = GREEN * 6
                    time.sleep(0.15)
                    pixels[10:16] = BLACK * 6
                    time.sleep(0.15)

def play_game(BC_score, DM_score, button_BC, button_DM):
    pixels[0:2] = BLACK * 2
    pixels[8:10] = BLACK * 2

    while (BC_score < 6 and DM_score < 6):

        button_BC.update()
        button_DM.update()

        if button_BC.pressed:
            BC_score += 1
            pixels[8-BC_score] = RED
            print(f"BC moves to {BC_score}")
        if button_DM.pressed:
            DM_score += 1
            pixels[16-DM_score] = GREEN
            print(f"DM moves to {DM_score}")

        if BC_score >= 6:
            print("BC Wins")
            BC_score = 0
            DM_score = 0
            play_sound_winner("BC")
            time.sleep(1.5)
            return
            #BC WINS AUDIO
            #RESET GAME
        if DM_score >= 6:
            print("DM Wins")
            BC_score = 0
            DM_score = 0
            play_sound_winner("DM")
            time.sleep(1.5)
            return
            #DM WINS AUDIO
            #RESET GAME


# colors
RED = (255, 0, 0)
GREEN = (50, 255, 20)
BLACK = (0, 0, 0)

# set up buttons
button_input_BC = digitalio.DigitalInOut(board.GP0) # Wired to GP15
button_input_BC.switch_to_input(digitalio.Pull.UP) # Note: Pull.UP for external buttons
button_BC = Button(button_input_BC) # NOTE: False for external buttons
button_input_DM = digitalio.DigitalInOut(board.GP1) # Wired to GP16
button_input_DM.switch_to_input(digitalio.Pull.UP) # Note: Pull.UP for external buttons
button_DM = Button(button_input_DM) # NOTE: False for external buttons

# set up the speaker
audio = AudioOut(board.GP16)
path = "/sd/"

# set up the lights
pixels = neopixel.NeoPixel(board.GP22, 16)

pixels.fill(BLACK)
BC_score, DM_score = 0, 0
while True:
    play_sound_begin("321-go.wav")
    pixels.fill(BLACK)
    play_game(BC_score, DM_score, button_BC, button_DM)
    pixels.fill(BLACK)

